#include <string.h>
#include <math.h>


unsigned char iI[50];
unsigned char iQ[50];
unsigned char iM[200];

unsigned long Time;
unsigned char ComRST;


//------------------------------------------------------------------------------
// 	Routine:	 
//------------------------------------------------------------------------------

void RST_IQM(void)
{
	unsigned char i;
	for (i=0; i<50; i++)
	{
	  iI[i]=0;
	  iQ[i]=0;
	}
}


struct sTbIN
{	
	unsigned char OUT;
};

struct sTbOUT
{
	unsigned char IN;
	unsigned char OUT;
};

struct sTiIN
{
	long OUT;
};

struct sTiOUT
{
	unsigned char useEN;
	unsigned char EN;
	long IN;
};

struct sTrIN
{
	float OUT;
};

struct sTrOUT
{
	unsigned char useEN;
	unsigned char EN;
	float IN;
};

struct sTbAND
{
	unsigned char IN1;
	unsigned char IN2;
	unsigned char IN3;
	unsigned char IN4;
	unsigned char OUT;
};

struct sTbOR
{
	unsigned char IN1;
	unsigned char IN2;
	unsigned char IN3;
	unsigned char IN4;
	unsigned char OUT;
};

struct sTbNOT
{
	unsigned char useEN; 
	unsigned char EN;
  	unsigned char ENO;
  	unsigned char IN;
  	unsigned char OUT;
};

struct sTbFP
{
	unsigned char useEN; 
	unsigned char EN;
  	unsigned char ENO;
  	unsigned char IN;
  	unsigned char OUT;
	unsigned char FMem;
};

struct sTbFN
{
	unsigned char useEN; 
	unsigned char EN;
  	unsigned char ENO;
  	unsigned char IN;
  	unsigned char OUT;
	unsigned char FMem;
};

struct sTbRS
{
  	unsigned char useEN;
    	unsigned char EN;
  	unsigned char ENO;
  	unsigned char R;
    	unsigned char S;
  	unsigned char OUT;
};

struct sTpTIMER
{
	unsigned char useEN;
    	unsigned char EN;
	unsigned char ENO;
	unsigned char S;
	unsigned int SP;
	unsigned char OUT;
	unsigned long EndTime;
	unsigned char PFS;
	unsigned char PFTic;
};

struct sTiADD
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	unsigned long IN1;
	unsigned long IN2;
	unsigned long OUT;
};

struct sTiSUBB
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	long IN1;
	long IN2;
	long OUT;
};

struct sTiMULL
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	long IN1;
	long IN2;
	long OUT;
};

struct sTiDIV
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	long IN1;
	long IN2;
	long OUT;
};

struct sTiEQ
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	long IN1;
	long IN2;
	unsigned char OUT;
};


struct sTiGT
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	long IN1;
	long IN2;
	unsigned char OUT;
};

struct sTiLS
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	long IN1;
	long IN2;
	unsigned char OUT;
};

struct sTiMOVE
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	long IN;
	long OUT;
};

struct sTiSHR
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	long IN1;
	unsigned char IN2;
	long OUT;
};

struct sTiSHL
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	long IN1;
	unsigned char IN2;
	long OUT;
};



struct sTrADD
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	float IN1;
	float IN2;
	float OUT;
};

struct sTrSUBB
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	float IN1;
	float IN2;
	float OUT;
};

struct sTrMULL
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	float IN1;
	float IN2;
	float OUT;
};

struct sTrDIV
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	float IN1;
	float IN2;
	float OUT;
};

struct sTrEQ
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	float IN1;
	float IN2;
	unsigned char OUT;
};

struct sTrGT
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	float IN1;
	float IN2;
	unsigned char OUT;
};

struct sTrLS
{
	unsigned char useEN;
     	unsigned char EN;
	char ENO;
	float IN1;
	float IN2;
	unsigned char OUT;
};


struct sTrMOVE
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	float IN;
	float OUT;
};

struct sTINT_TO_FLT
{
	unsigned char useEN;
     	unsigned char EN;
	unsigned char ENO;
	long IN;
	float OUT;
};

struct sTFLT_TO_INT
{
	unsigned char useEN;
    	unsigned char EN;
	unsigned char ENO;
	float IN;
	long OUT;
};

struct sTpGEN
{
	unsigned char useEN;
    	unsigned char EN;
	unsigned char ENO;
	unsigned int MODE;
	float SP;
	float OUT;
	float ARG;
};


struct sTpPID
{
	unsigned char useEN;
    	unsigned char EN;
	unsigned char ENO;
	float SP_A;
	float PV;
	float Dead;
	float Kp;
	float Ti;
	float Td;
	float Cycle;
	float SP_M;
	unsigned char AM;
	float LMN_Hi;
	float LMN_Lo;
	float LMN;
	float Err;
	unsigned char L_Hi;
	unsigned char L_Lo;
	float FIntegral;
	float FPrevVal;
};



void *Sdv( void *Data, unsigned int Num)
{
 char  b;
 char *D;
 unsigned int i;

 D= (char *)Data;
 for( i=0; i<(Num/2); i++)
  {
   b= D[i];
   D[i]= D[Num-1-i];
   D[Num-1-i]= b;
  }
  
 return Data;
}

void fTbIN(struct sTbIN *var,unsigned char MemType, unsigned char Byte,unsigned char Bit)
{
 unsigned char temp; 

 temp=0;
 switch (MemType)
  {
   case 0: temp=(iI[Byte] >> Bit) & 1; break;
   case 1: temp=(iQ[Byte] >> Bit) & 1; break;
   case 2: temp=(iM[Byte] >> Bit) & 1; break;
  }
  var->OUT=temp;
}


void fTbOUT(struct sTbOUT *var,unsigned char MemType,unsigned char Byte,unsigned char Bit,unsigned char Action)
{
 unsigned char temp,nottemp;

  temp=1 << Bit;
  nottemp=~temp;
  switch (Action)
  {
   case 0: var->OUT=var->IN; break;
   case 1: if (var->IN) {var->OUT=1;} break;
   case 2: if (var->IN) {var->OUT=0;} break;
  }
  switch (MemType)
  {
   case 0: if (var->OUT) iI[Byte]=iI[Byte] | temp; else iI[Byte]=iI[Byte] & nottemp; break;
   case 1: if (var->OUT) iQ[Byte]=iQ[Byte] | temp; else iQ[Byte]=iQ[Byte] & nottemp; break;
   case 2: if (var->OUT) iM[Byte]=iM[Byte] | temp; else iM[Byte]=iM[Byte] & nottemp; break;
  }
}


void fTiIN(struct sTiIN *var,unsigned char MemType,unsigned char Byte,unsigned char Count)
{
long temp;
 
 temp=0;
 switch (MemType)
 {
   case 0: memcpy( &temp, iI+Byte, Count); break;
   case 1: memcpy( &temp, iQ+Byte, Count); break;
   case 2: memcpy( &temp, iM+Byte, Count); break;
 } 
 //Sdv( &temp, 4); 
 var->OUT=temp;
}

void fTiOUT(struct sTiOUT *var,unsigned char MemType,unsigned char Byte,unsigned char Count)
{
long temp;

 if (var->EN)
 {
 temp=var->IN;
// Sdv( &temp, 4);
 switch (MemType)
 {
   case 0: memcpy( iI+Byte,&temp, Count); break;
   case 1: memcpy( iQ+Byte,&temp, Count); break;
   case 2: memcpy( iM+Byte,&temp, Count); break;
 }
 } 
}

void fTrIN(struct sTrIN *var,unsigned char MemType,unsigned char Byte)
{
float temp;
 
 temp=0;
 switch (MemType)
 {
   case 0: memcpy( &temp, iI+Byte, 4); break;
   case 1: memcpy( &temp, iQ+Byte, 4); break;
   case 2: memcpy( &temp, iM+Byte, 4); break;
 } 
// Sdv( &temp, 4); 
 var->OUT=temp;
}

void fTrOUT(struct sTrOUT *var,unsigned char MemType,unsigned char Byte)
{
float temp;

 if (var->EN)
 {
 temp=var->IN;
// Sdv( &temp, 4);
 switch (MemType)
 {
   case 0: memcpy( iI+Byte,&temp, 4); break;
   case 1: memcpy( iQ+Byte,&temp, 4); break;
   case 2: memcpy( iM+Byte,&temp, 4); break;
 }
 } 
}

void fTbAND(struct sTbAND *var,unsigned char num)
{
 switch (num)
 {
   case 2: var->OUT=var->IN1&var->IN2; break;
   case 3: var->OUT=var->IN1&var->IN2&var->IN3; break;
   case 4: var->OUT=var->IN1&var->IN2&var->IN3&var->IN4; break;
 }
}

void fTbOR(struct sTbOR *var,unsigned char num)
{
 switch (num)
 {
   case 2: var->OUT=var->IN1|var->IN2; break;
   case 3: var->OUT=var->IN1|var->IN2|var->IN3; break;
   case 4: var->OUT=var->IN1|var->IN2|var->IN3|var->IN4; break;
 }
}

void fTbNOT(struct sTbNOT *var)
{
 unsigned char EN;
 EN=!var->useEN | var->EN;

 var->ENO=EN;

 var->OUT=!var->IN & EN;

}

void fTbFP(struct sTbFP *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->FMem=0;
   var->OUT=0;
   return;
 }

 EN=!var->useEN | var->EN;

 var->ENO=EN;

 var->OUT=var->IN && !var->FMem && EN;
 var->FMem=var->IN;
}

void fTbFN(struct sTbFN *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->FMem=0;
   var->OUT=0;
   return;
 }

 EN=!var->useEN | var->EN;

 var->ENO=EN;

 var->OUT=!var->IN && var->FMem && EN;
 var->FMem=var->IN;
}

void fTbRS(struct sTbRS *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN | var->EN;

 var->ENO=EN;

 if (var->R) var->OUT=0;
 if (var->S) var->OUT=1;

 var->OUT=var->OUT && EN;
}

void fTpTIMER(struct sTpTIMER *var,unsigned char Mode)
{
unsigned char EN;

 EN=!var->useEN | var->EN;
 var->ENO=EN;

 if (EN && !ComRST)
 {
     switch (Mode)
	{
	case 0:
	case 1:
	case 2: 
	  if (var->S && !var->PFS) var->EndTime=Time + var->SP*1.4; break;
	case 3:
          if (!var->S && var->PFS) var->EndTime=Time + var->SP*1.4; break;
	}

    if (var->EndTime<Time) var->EndTime=Time;

     switch (Mode)
	{
	case 0:
	case 2:
	  if (!(var->S)) var->EndTime=Time; break;
	case 3:    
	  if (var->S) var->EndTime=Time; break;
	}


    switch (Mode)
	{
	case 0:
	case 1:
	  var->OUT= var->EndTime>Time; break;
	case 2:
	  var->OUT= (var->EndTime<=Time) && var->S; break;
	case 3:
          var->OUT= (var->EndTime>Time) || var->S; break;
    }

     var->PFS=var->S;
 }
 else 
 {
   var->PFS=0;
   var->OUT=0;
   var->EndTime=Time;
 }

}

void fTiADD(struct sTiADD *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }
 EN=!var->useEN || var->EN;

 var->ENO=EN;

 if (EN) var->OUT=var->IN1+var->IN2;
}

void fTiSUBB(struct sTiSUBB *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 if (EN) var->OUT=var->IN1 - var->IN2;
}


void fTiMULL(struct sTiMULL *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }
 EN=!var->useEN || var->EN;

 var->ENO=EN;

 if (EN) var->OUT=var->IN1 * var->IN2;
}


void fTiDIV(struct sTiDIV *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 if (EN) var->OUT=var->IN1 / var->IN2;
}



void fTiEQ(struct sTiEQ *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 var->OUT=EN && var->IN1==var->IN2;
}

void fTiGT(struct sTiGT *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 var->OUT=EN && var->IN1>var->IN2;
}

void fTiLS(struct sTiLS *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 var->OUT=EN && var->IN1<var->IN2;
}

void fTiMOVE(struct sTiMOVE *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 if (EN) var->OUT=var->IN;
}

void fTiSHR(struct sTiSHR *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 if (EN) var->OUT=var->IN1 >> var->IN2;
}

void fTiSHL(struct sTiSHL *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 if (EN) var->OUT=var->IN1 << var->IN2;
}

void fTrADD(struct sTrADD *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 if (EN) var->OUT=var->IN1+var->IN2;
}

void fTrSUBB(struct sTrSUBB *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 if (EN) var->OUT=var->IN1 - var->IN2;
}


void fTrMULL(struct sTrMULL *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 if (EN) var->OUT=var->IN1 * var->IN2;
}


void fTrDIV(struct sTrDIV *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 if (EN) var->OUT=var->IN1 / var->IN2;
}


void fTrEQ(struct sTrEQ *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 var->OUT=EN && var->IN1==var->IN2;
}

void fTrGT(struct sTrGT *var)
{
 unsigned char EN;
 EN=!var->useEN || var->EN;

 var->ENO=EN;

 var->OUT=EN && var->IN1>var->IN2;
}

void fTrLS(struct sTrLS *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 var->OUT=EN && var->IN1<var->IN2;
}


void fTrMOVE(struct sTrMOVE *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 if (EN) var->OUT=var->IN;
}


void fTINT_TO_FLT(struct sTINT_TO_FLT *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 if (EN) var->OUT=var->IN;
}

void fTFLT_TO_INT(struct sTFLT_TO_INT *var)
{
 unsigned char EN;

 if (ComRST)
 {
   var->OUT=0;
   return;
 }

 EN=!var->useEN || var->EN;

 var->ENO=EN;

 if (EN) var->OUT=var->IN;
}



void fTpGEN(struct sTpGEN *var)
{
 unsigned char EN;

 if (var->SP<1) return;
 EN=!var->useEN || var->EN;
 var->ENO=EN;

 if (EN && !ComRST) 
 {
  var->ARG=fabsf(var->ARG); 
  if (var->ARG < 1) var->ARG+=1/var->SP; else var->ARG=0;
  switch (var->MODE)
  {
	case 0: var->OUT=sinf(var->ARG*6.28);	break;
	case 1: if (var->ARG > 0.5) var->OUT=1; else var->OUT=0; break;
	default: var->OUT=0; break;
  }
 }
 else
 {
   var->OUT=0;
   var->ARG=0;
 }
}


void fTpPID(struct sTpPID *var)
{
 unsigned char EN;
 float Ki;
 float Kd;
 float FOUT;

 EN=!var->useEN || var->EN;
 var->ENO=EN;

 if (EN && !ComRST) 
 {
   if (var->Ti>0.0) Ki= var->Kp * var->Cycle / var->Ti; else Ki=0; //Ki = Kp * T / Ti;
   if (var->Cycle>0.0) Kd= var->Kp * var->Td / var->Cycle; else Kd=0;  //Kd = Kp * Td / T;
   if (!var->AM)
   {
    var->Err=var->SP_A - var->PV;
    if (fabsf(var->Err)>var->Dead)
    { 
     if (!((var->L_Hi && (var->Err>0.0)) || (var->L_Lo && (var->Err<0.0))))
      var->FIntegral+=var->Err;

    FOUT=var->Kp*var->Err + Ki*var->FIntegral +Kd*(var->FPrevVal-var->PV); // Out = Kp * Error + Ki * Integral  + Kd * (PrevValue - Value);
    if (fabsf(var->Err)>var->Dead)
    {
     if (FOUT>var->LMN_Hi) {var->LMN=var->LMN_Hi; var->L_Hi=0xFF;}
     else if (FOUT<var->LMN_Lo) {var->LMN=var->LMN_Lo; var->L_Lo=0xFF;}
     else {var->LMN=FOUT; var->L_Hi=0; var->L_Lo=0;}
    }
    }	
	
    var->FPrevVal=var->PV;
   }
   else
   {
    var->LMN=var->SP_M;
    if (Ki>0.0) var->FIntegral=(var->LMN - var->Kp * var->Err)/Ki; else var->FIntegral=0;  // Integral:=(Out-Kp * Error-Kd * (PrevValue - Value))/Ki
    var->FPrevVal=var->PV;
   }

 }
 else
 {
   var->FIntegral=0;
   var->FPrevVal=var->PV;
 }
}